#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
helper class for making a SAT frontend
Copyright (C) 2009, 2010  Jérôme Poisson (goffi@goffi.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

from logging import debug, info, error
from tools.jid  import JID



class QuickChat():
    
    def __init__(self, to_jid, host):
        self.to_jid = to_jid
        self.host = host

    def historyPrint(self, size=20, keep_last=False, profile='@NONE@'):
        """Print the initial history"""
        debug ("now we print history")
        history=self.host.bridge.getHistory(self.host.profiles[profile]['whoami'].short, self.to_jid, 20)
        stamps=history.keys()
        stamps.sort()
        for stamp in stamps: 
            self.printMessage(JID(history[stamp][0]), history[stamp][1], profile, stamp)
        if keep_last:  ##FIXME hack for sortilege
            self.last_history = stamps[-1] if stamps else None

    def printMessage(self, from_jid, msg, profile, timestamp):
        """Print message in chat window. Must be implemented by child class"""
        raise NotImplementedError
    
